Index: src/includes/classes/Smarty/sysplugins/smarty_internal_resource_file.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_resource_file.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_resource_file.php	(revision )
@@ -18,6 +18,97 @@
 class Smarty_Internal_Resource_File extends Smarty_Resource
 {
     /**
+     * build template filepath by traversing the template_dir array
+     *
+     * @param Smarty_Template_Source    $source    source object
+     * @param  Smarty_Internal_Template $_template template object
+     *
+     * @return string fully qualified filepath
+     * @throws SmartyException
+     */
+    protected function buildFilepath(Smarty_Template_Source $source, Smarty_Internal_Template $_template = null)
+    {
+        $file = $source->name;
+        // absolute file ?
+        if ($file[0] == '/' || $file[1] == ':') {
+            $file = $source->smarty->_realpath($file, true);
+            return is_file($file) ? $file : false;
+        }
+        // go relative to a given template?
+        if ($file[0] == '.' && $_template && isset($_template->parent) && $_template->parent->_objType == 2 &&
+            preg_match('#^[.]{1,2}[\\\/]#', $file)
+        ) {
+            if ($_template->parent->source->type != 'file' && $_template->parent->source->type != 'extends' &&
+                !isset($_template->parent->_cache['allow_relative_path'])
+            ) {
+                throw new SmartyException("Template '{$file}' cannot be relative to template of resource type '{$_template->parent->source->type}'");
+            }
+            $path = dirname($_template->parent->source->filepath) . DS . $file;
+            // normalize path
+            $path = $source->smarty->_realpath($path);
+            // files relative to a template only get one shot
+            return is_file($path) ? $path : false;
+        }
+        // normalize DS
+        if (strpos($file, DS == '/' ? '\\' : '/') !== false) {
+            $file = str_replace(DS == '/' ? '\\' : '/', DS, $file);
+        }
+
+        $_directories = $source->smarty->getTemplateDir(null, $source->isConfig);
+        // template_dir index?
+        if ($file[0] == '[' && preg_match('#^\[([^\]]+)\](.+)$#', $file, $fileMatch)) {
+            $file = $fileMatch[2];
+            $_indices = explode(',', $fileMatch[1]);
+            $_index_dirs = array();
+            foreach ($_indices as $index) {
+                $index = trim($index);
+                // try string indexes
+                if (isset($_directories[$index])) {
+                    $_index_dirs[] = $_directories[$index];
+                } elseif (is_numeric($index)) {
+                    // try numeric index
+                    $index = (int) $index;
+                    if (isset($_directories[$index])) {
+                        $_index_dirs[] = $_directories[$index];
+                    } else {
+                        // try at location index
+                        $keys = array_keys($_directories);
+                        if (isset($_directories[$keys[$index]])) {
+                            $_index_dirs[] = $_directories[$keys[$index]];
+                        }
+                    }
+                }
+            }
+            if (empty($_index_dirs)) {
+                // index not found
+                return false;
+            } else {
+                $_directories = $_index_dirs;
+            }
+        }
+
+        // relative file name?
+        foreach ($_directories as $_directory) {
+            $path = $_directory . $file;
+            if (is_file($path)) {
+                return (strpos($path, '.' . DS) !== false) ? $source->smarty->_realpath($path) : $path;
+            }
+        }
+        if (!isset($_index_dirs)) {
+            // Could be relative to cwd
+            $path = $source->smarty->_realpath($file, true);
+            if (is_file($path)) {
+                return $path;
+            }
+        }
+        // Use include path ?
+        if ($source->smarty->use_include_path) {
+            return $source->smarty->ext->_getIncludePath->getIncludePath($_directories, $file, $source->smarty);
+        }
+        return false;
+    }
+
+    /**
      * populate Source Object with meta data from Resource
      *
      * @param Smarty_Template_Source   $source    source object
@@ -28,15 +119,17 @@
         $source->filepath = $this->buildFilepath($source, $_template);
 
         if ($source->filepath !== false) {
-            if (is_object($source->smarty->security_policy)) {
-                $source->smarty->security_policy->isTrustedResourceDir($source->filepath);
+            if (isset($source->smarty->security_policy) && is_object($source->smarty->security_policy)) {
+                $source->smarty->security_policy->isTrustedResourceDir($source->filepath, $source->isConfig);
             }
-
-            $source->uid = sha1(realpath($source->filepath));
-            if ($source->smarty->compile_check && !isset($source->timestamp)) {
-                $source->timestamp = @filemtime($source->filepath);
-                $source->exists = !!$source->timestamp;
+            $source->exists = true;
+            $source->uid = sha1($source->filepath);
+            if ($source->smarty->compile_check == 1) {
+                $source->timestamp = filemtime($source->filepath);
             }
+        } else {
+            $source->timestamp = false;
+            $source->exists = false;
         }
     }
 
@@ -47,9 +140,13 @@
      */
     public function populateTimestamp(Smarty_Template_Source $source)
     {
-        $source->timestamp = @filemtime($source->filepath);
-        $source->exists = !!$source->timestamp;
+        if (!$source->exists) {
+            $source->timestamp = $source->exists = is_file($source->filepath);
-    }
+        }
+        if ($source->exists) {
+            $source->timestamp = filemtime($source->filepath);
+        }
+    }
 
     /**
      * Load template's source from file into current template object
@@ -61,14 +158,12 @@
      */
     public function getContent(Smarty_Template_Source $source)
     {
-        if ($source->timestamp) {
+        if ($source->exists) {
             return file_get_contents($source->filepath);
         }
-        if ($source instanceof Smarty_Config_Source) {
-            throw new SmartyException("Unable to read config {$source->type} '{$source->name}'");
+        throw new SmartyException('Unable to read ' . ($source->isConfig ? 'config' : 'template') .
+                                  " {$source->type} '{$source->name}'");
-        }
+    }
-        throw new SmartyException("Unable to read template {$source->type} '{$source->name}'");
-    }
 
     /**
      * Determine basename for compiled filename
@@ -79,11 +174,6 @@
      */
     public function getBasename(Smarty_Template_Source $source)
     {
-        $_file = $source->name;
-        if (($_pos = strpos($_file, ']')) !== false) {
-            $_file = substr($_file, $_pos + 1);
-        }
-
-        return basename($_file);
+        return basename($source->filepath);
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_validatecompiled.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_validatecompiled.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_validatecompiled.php	(revision )
@@ -0,0 +1,86 @@
+<?php
+
+/**
+ * Runtime Methods decodeProperties
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_ValidateCompiled
+{
+    /**
+     * This function is executed automatically when a compiled or cached template file is included
+     * - Decode saved properties from compiled template and cache files
+     * - Check if compiled or cache file is valid
+     *
+     * @param  array $properties special template properties
+     * @param  bool  $cache      flag if called from cache file
+     *
+     * @return bool  flag if compiled or cache file is valid
+     */
+    public function decodeProperties(Smarty_Internal_Template $tpl, $properties, $cache = false)
+    {
+        $is_valid = true;
+        if (Smarty::SMARTY_VERSION != $properties['version']) {
+            // new version must rebuild
+            $is_valid = false;
+        } elseif ($is_valid && !empty($properties['file_dependency']) &&
+            ((!$cache && $tpl->smarty->compile_check) || $tpl->smarty->compile_check == 1)
+        ) {
+            // check file dependencies at compiled code
+            foreach ($properties['file_dependency'] as $_file_to_check) {
+                if ($_file_to_check[2] == 'file' || $_file_to_check[2] == 'extends' || $_file_to_check[2] == 'php') {
+                    if ($tpl->source->filepath == $_file_to_check[0]) {
+                        // do not recheck current template
+                        continue;
+                        //$mtime = $tpl->source->getTimeStamp();
+                    } else {
+                        // file and php types can be checked without loading the respective resource handlers
+                        $mtime = is_file($_file_to_check[0]) ? filemtime($_file_to_check[0]) : false;
+                    }
+                } elseif ($_file_to_check[2] == 'string') {
+                    continue;
+                } else {
+                    $handler = Smarty_Resource::load($tpl->smarty, $_file_to_check[2]);
+                    if ($handler->checkTimestamps()) {
+                        $source = Smarty_Template_Source::load($tpl, $tpl->smarty, $_file_to_check[ 0 ]);
+                        $mtime = $source->getTimeStamp();
+                    } else {
+                        continue;
+                    }
+                }
+                if (!$mtime || $mtime > $_file_to_check[1]) {
+                    $is_valid = false;
+                    break;
+                }
+            }
+        }
+        if ($cache) {
+            // CACHING_LIFETIME_SAVED cache expiry has to be validated here since otherwise we'd define the unifunc
+            if ($tpl->caching === Smarty::CACHING_LIFETIME_SAVED && $properties['cache_lifetime'] >= 0 &&
+                (time() > ($tpl->cached->timestamp + $properties['cache_lifetime']))
+            ) {
+                $is_valid = false;
+            }
+            $tpl->cached->cache_lifetime = $properties['cache_lifetime'];
+            $tpl->cached->valid = $is_valid;
+            $resource = $tpl->cached;
+        } else {
+            $tpl->mustCompile = !$is_valid;
+            $resource = $tpl->compiled;
+            $resource->includes = isset($properties['includes']) ? $properties['includes'] : array();
+        }
+        if ($is_valid) {
+            $resource->unifunc = $properties['unifunc'];
+            $resource->has_nocache_code = $properties['has_nocache_code'];
+            //            $tpl->compiled->nocache_hash = $properties['nocache_hash'];
+            $resource->file_dependency = $properties['file_dependency'];
+            if (isset($properties['tpl_function'])) {
+                $tpl->tpl_function = $properties['tpl_function'];
+            }
+        }
+        return $is_valid && !function_exists($properties['unifunc']);
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_block_plugin.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_block_plugin.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_block_plugin.php	(revision )
@@ -27,15 +27,15 @@
     /**
      * Compiles code for the execution of block plugin
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
-     * @param  string $tag       name of block plugin
+     * @param  string                               $tag       name of block plugin
-     * @param  string $function  PHP function name
+     * @param  string                               $function  PHP function name
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter, $tag, $function)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter, $tag, $function)
     {
         if (!isset($tag[5]) || substr($tag, - 5) != 'close') {
             // opening tag of block plugin
@@ -60,7 +60,7 @@
             // maybe nocache because of nocache variables or nocache plugin
             $compiler->nocache = $compiler->nocache | $compiler->tag_nocache;
             // compile code
-            $output = "<?php \$_smarty_tpl->smarty->_tag_stack[] = array('{$tag}', {$_params}); \$_block_repeat=true; echo {$function}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
+            $output = "<?php \$_smarty_tpl->smarty->_cache['tag_stack'][] = array('{$tag}', {$_params}); \$_block_repeat=true; echo {$function}({$_params}, null, \$_smarty_tpl, \$_block_repeat);while (\$_block_repeat) { ob_start();?>";
         } else {
             // must endblock be nocache?
             if ($compiler->nocache) {
@@ -75,9 +75,13 @@
                 $mod_pre = $mod_post = '';
             } else {
                 $mod_pre = ' ob_start(); ';
-                $mod_post = 'echo ' . $compiler->compileTag('private_modifier', array(), array('modifierlist' => $parameter['modifier_list'], 'value' => 'ob_get_clean()')) . ';';
+                $mod_post = 'echo ' .
+                    $compiler->compileTag('private_modifier', array(), array('modifierlist' => $parameter['modifier_list'],
+                                                                             'value'        => 'ob_get_clean()')) . ';';
             }
-            $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre . " echo {$function}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat); " . $mod_post . " } array_pop(\$_smarty_tpl->smarty->_tag_stack);?>";
+            $output = "<?php \$_block_content = ob_get_clean(); \$_block_repeat=false;" . $mod_pre .
+                " echo {$function}({$_params}, \$_block_content, \$_smarty_tpl, \$_block_repeat); " . $mod_post .
+                " } array_pop(\$_smarty_tpl->smarty->_cache['tag_stack']);?>";
         }
 
         return $output . "\n";
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_for.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_for.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_for.php	(revision )
@@ -34,6 +34,7 @@
      */
     public function compile($args, $compiler, $parameter)
     {
+        $compiler->loopNesting++;
         if ($parameter == 0) {
             $this->required_attributes = array('start', 'to');
             $this->optional_attributes = array('max', 'step');
@@ -44,30 +45,51 @@
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
 
-        $output = "<?php ";
+        $output = "<?php\n";
         if ($parameter == 1) {
             foreach ($_attr['start'] as $_statement) {
-                $output .= " \$_smarty_tpl->tpl_vars[$_statement[var]] = new Smarty_Variable;";
-                $output .= " \$_smarty_tpl->tpl_vars[$_statement[var]]->value = $_statement[value];\n";
+                if (is_array($_statement['var'])) {
+                    $var = $_statement['var']['var'];
+                    $index = $_statement['var']['smarty_internal_index'];
+                } else {
+                    $var = $_statement['var'];
+                    $index = '';
-            }
+                }
-            $output .= "  if ($_attr[ifexp]) { for (\$_foo=true;$_attr[ifexp]; \$_smarty_tpl->tpl_vars[$_attr[var]]->value$_attr[step]) {\n";
+                $output .= "\$_smarty_tpl->tpl_vars[$var] = new Smarty_Variable;\n";
+                $output .= "\$_smarty_tpl->tpl_vars[$var]->value{$index} = {$_statement['value']};\n";
+            }
+            if (is_array($_attr['var'])) {
+                $var = $_attr['var']['var'];
+                $index = $_attr['var']['smarty_internal_index'];
-        } else {
+            } else {
+                $var = $_attr['var'];
+                $index = '';
+            }
+            $output .= "if ($_attr[ifexp]) {\nfor (\$_foo=true;$_attr[ifexp]; \$_smarty_tpl->tpl_vars[$var]->value{$index}$_attr[step]) {\n";
+        } else {
             $_statement = $_attr['start'];
-            $output .= "\$_smarty_tpl->tpl_vars[$_statement[var]] = new Smarty_Variable;";
+            if (is_array($_statement['var'])) {
+                $var = $_statement['var']['var'];
+                $index = $_statement['var']['smarty_internal_index'];
+            } else {
+                $var = $_statement['var'];
+                $index = '';
+            }
+            $output .= "\$_smarty_tpl->tpl_vars[$var] = new Smarty_Variable;";
             if (isset($_attr['step'])) {
-                $output .= "\$_smarty_tpl->tpl_vars[$_statement[var]]->step = $_attr[step];";
+                $output .= "\$_smarty_tpl->tpl_vars[$var]->step = $_attr[step];";
             } else {
-                $output .= "\$_smarty_tpl->tpl_vars[$_statement[var]]->step = 1;";
+                $output .= "\$_smarty_tpl->tpl_vars[$var]->step = 1;";
             }
             if (isset($_attr['max'])) {
-                $output .= "\$_smarty_tpl->tpl_vars[$_statement[var]]->total = (int) min(ceil((\$_smarty_tpl->tpl_vars[$_statement[var]]->step > 0 ? $_attr[to]+1 - ($_statement[value]) : $_statement[value]-($_attr[to])+1)/abs(\$_smarty_tpl->tpl_vars[$_statement[var]]->step)),$_attr[max]);\n";
+                $output .= "\$_smarty_tpl->tpl_vars[$var]->total = (int) min(ceil((\$_smarty_tpl->tpl_vars[$var]->step > 0 ? $_attr[to]+1 - ($_statement[value]) : $_statement[value]-($_attr[to])+1)/abs(\$_smarty_tpl->tpl_vars[$var]->step)),$_attr[max]);\n";
             } else {
-                $output .= "\$_smarty_tpl->tpl_vars[$_statement[var]]->total = (int) ceil((\$_smarty_tpl->tpl_vars[$_statement[var]]->step > 0 ? $_attr[to]+1 - ($_statement[value]) : $_statement[value]-($_attr[to])+1)/abs(\$_smarty_tpl->tpl_vars[$_statement[var]]->step));\n";
+                $output .= "\$_smarty_tpl->tpl_vars[$var]->total = (int) ceil((\$_smarty_tpl->tpl_vars[$var]->step > 0 ? $_attr[to]+1 - ($_statement[value]) : $_statement[value]-($_attr[to])+1)/abs(\$_smarty_tpl->tpl_vars[$var]->step));\n";
             }
-            $output .= "if (\$_smarty_tpl->tpl_vars[$_statement[var]]->total > 0) {\n";
-            $output .= "for (\$_smarty_tpl->tpl_vars[$_statement[var]]->value = $_statement[value], \$_smarty_tpl->tpl_vars[$_statement[var]]->iteration = 1;\$_smarty_tpl->tpl_vars[$_statement[var]]->iteration <= \$_smarty_tpl->tpl_vars[$_statement[var]]->total;\$_smarty_tpl->tpl_vars[$_statement[var]]->value += \$_smarty_tpl->tpl_vars[$_statement[var]]->step, \$_smarty_tpl->tpl_vars[$_statement[var]]->iteration++) {\n";
-            $output .= "\$_smarty_tpl->tpl_vars[$_statement[var]]->first = \$_smarty_tpl->tpl_vars[$_statement[var]]->iteration == 1;";
-            $output .= "\$_smarty_tpl->tpl_vars[$_statement[var]]->last = \$_smarty_tpl->tpl_vars[$_statement[var]]->iteration == \$_smarty_tpl->tpl_vars[$_statement[var]]->total;";
+            $output .= "if (\$_smarty_tpl->tpl_vars[$var]->total > 0) {\n";
+            $output .= "for (\$_smarty_tpl->tpl_vars[$var]->value{$index} = $_statement[value], \$_smarty_tpl->tpl_vars[$var]->iteration = 1;\$_smarty_tpl->tpl_vars[$var]->iteration <= \$_smarty_tpl->tpl_vars[$var]->total;\$_smarty_tpl->tpl_vars[$var]->value{$index} += \$_smarty_tpl->tpl_vars[$var]->step, \$_smarty_tpl->tpl_vars[$var]->iteration++) {\n";
+            $output .= "\$_smarty_tpl->tpl_vars[$var]->first = \$_smarty_tpl->tpl_vars[$var]->iteration == 1;";
+            $output .= "\$_smarty_tpl->tpl_vars[$var]->last = \$_smarty_tpl->tpl_vars[$var]->iteration == \$_smarty_tpl->tpl_vars[$var]->total;";
         }
         $output .= "?>";
 
@@ -127,6 +149,7 @@
      */
     public function compile($args, $compiler, $parameter)
     {
+        $compiler->loopNesting--;
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
         // must endblock be nocache?
@@ -136,10 +159,11 @@
 
         list($openTag, $compiler->nocache) = $this->closeTag($compiler, array('for', 'forelse'));
 
-        if ($openTag == 'forelse') {
-            return "<?php }  ?>";
-        } else {
-            return "<?php }} ?>";
+        $output = "<?php }\n";
+        if ($openTag != 'forelse') {
+            $output .= "}\n";
-        }
+         }
+        $output .= "?>\n";
+        return $output;
     }
 }
Index: src/includes/classes/Smarty/plugins/modifiercompiler.strip.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.strip.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.strip.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_compileallconfig.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_compileallconfig.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_compileallconfig.php	(revision )
@@ -0,0 +1,32 @@
+<?php
+
+/**
+ * Smarty Method CompileAllConfig
+ *
+ * Smarty::compileAllConfig() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_CompileAllConfig extends Smarty_Internal_Method_CompileAllTemplates
+{
+
+    /**
+     * Compile all config files
+     *
+     * @api  Smarty::compileAllConfig()
+     *
+     * @param \Smarty $smarty
+     * @param  string $extension     file extension
+     * @param  bool   $force_compile force all to recompile
+     * @param  int    $time_limit
+     * @param  int    $max_errors
+     *
+     * @return integer number of template files recompiled
+     */
+    public function compileAllConfig(Smarty $smarty, $extension = '.conf', $force_compile = false, $time_limit = 0, $max_errors = null)
+    {
+        return $this->compileAll($smarty, $extension, $force_compile, $time_limit, $max_errors, true);
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/modifiercompiler.default.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.default.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.default.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_getincludepath.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_getincludepath.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_getincludepath.php	(revision )
@@ -0,0 +1,180 @@
+<?php
+/**
+ * Smarty read include path plugin
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Monte Ohrt
+ */
+
+/**
+ * Smarty Internal Read Include Path Class
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ */
+class Smarty_Internal_Runtime_GetIncludePath
+{
+    /**
+     * include path cache
+     *
+     * @var string
+     */
+    public $_include_path = '';
+
+    /**
+     * include path directory cache
+     *
+     * @var array
+     */
+    public $_include_dirs = array();
+
+    /**
+     * include path directory cache
+     *
+     * @var array
+     */
+    public $_user_dirs = array();
+
+    /**
+     * stream cache
+     *
+     * @var string[]
+     */
+    public $isFile = array();
+
+    /**
+     * stream cache
+     *
+     * @var string[]
+     */
+    public $isPath = array();
+
+    /**
+     * stream cache
+     *
+     * @var int[]
+     */
+    public $number = array();
+
+    /**
+     * status cache
+     *
+     * @var bool
+     */
+    public $_has_stream_include = null;
+
+    /**
+     * Number for array index
+     *
+     * @var int
+     */
+    public $counter = 0;
+
+    /**
+     * Check if include path was updated
+     *
+     * @param \Smarty $smarty
+     *
+     * @return bool
+     */
+    public function isNewIncludePath(Smarty $smarty)
+    {
+        $_i_path = get_include_path();
+        if ($this->_include_path != $_i_path) {
+            $this->_include_dirs = array();
+            $this->_include_path = $_i_path;
+            $_dirs = (array) explode(PATH_SEPARATOR, $_i_path);
+            foreach ($_dirs as $_path) {
+                if (is_dir($_path)) {
+                    $this->_include_dirs[] = $smarty->_realpath($_path . DS, true);
+                }
+            }
+            return true;
+        }
+        return false;
+    }
+
+    /**
+     * return array with include path directories
+     *
+     * @param \Smarty $smarty
+     *
+     * @return array
+     */
+    public function getIncludePathDirs(Smarty $smarty)
+    {
+        $this->isNewIncludePath($smarty);
+        return $this->_include_dirs;
+    }
+
+    /**
+     * Return full file path from PHP include_path
+     *
+     * @param  string[] $dirs
+     * @param  string   $file
+     * @param \Smarty   $smarty
+     *
+     * @return bool|string full filepath or false
+     *
+     */
+    public function getIncludePath($dirs, $file, Smarty $smarty)
+    {
+        //if (!(isset($this->_has_stream_include) ? $this->_has_stream_include : $this->_has_stream_include = false)) {
+           if (!(isset($this->_has_stream_include) ? $this->_has_stream_include : $this->_has_stream_include = function_exists('stream_resolve_include_path'))) {
+                $this->isNewIncludePath($smarty);
+        }
+        // try PHP include_path
+        foreach ($dirs as $dir) {
+            $dir_n = isset($this->number[$dir]) ? $this->number[$dir] : $this->number[$dir] = $this->counter ++;
+            if (isset($this->isFile[$dir_n][$file])) {
+                if ($this->isFile[$dir_n][$file]) {
+                    return $this->isFile[$dir_n][$file];
+                } else {
+                    continue;
+                }
+            }
+            if (isset($this->_user_dirs[$dir_n])) {
+                if (false === $this->_user_dirs[$dir_n]) {
+                    continue;
+                } else {
+                    $dir = $this->_user_dirs[$dir_n];
+                }
+            } else {
+                if ($dir[0] == '/' || $dir[1] == ':') {
+                    $dir = str_ireplace(getcwd(), '.', $dir);
+                    if ($dir[0] == '/' || $dir[1] == ':') {
+                        $this->_user_dirs[$dir_n] = false;
+                        continue;
+                    }
+                }
+                $dir = substr($dir, 2);
+                $this->_user_dirs[$dir_n] = $dir;
+            }
+            if ($this->_has_stream_include) {
+                $path = stream_resolve_include_path($dir . (isset($file) ? $file : ''));
+                if ($path) {
+                    return $this->isFile[$dir_n][$file] = $path;
+                }
+            } else {
+                foreach ($this->_include_dirs as $key => $_i_path) {
+                    $path = isset($this->isPath[$key][$dir_n]) ? $this->isPath[$key][$dir_n] : $this->isPath[$key][$dir_n] = is_dir($_dir_path = $_i_path .
+                        $dir) ? $_dir_path : false;
+                    if ($path === false) {
+                        continue;
+                    }
+                    if (isset($file)) {
+                        $_file = $this->isFile[$dir_n][$file] = (is_file($path . $file)) ? $path . $file : false;
+                        if ($_file) {
+                            return $_file;
+                        }
+                    } else {
+                        // no file was given return directory path
+                        return $path;
+                    }
+                }
+            }
+        }
+        return false;
+    }
+}
